cbuffer cb2 : register(b2)
{
  float4 cb2[21];
}

cbuffer cb1 : register(b1)
{
  float4 cb1[4];
}

cbuffer cb0 : register(b0)
{
  float4 cb0[10];
}

// 3Dmigoto declarations
#define cmp -
Texture1D<float4> IniParams : register(t120);
Texture2D<float4> StereoParams : register(t125);

#define SIZE IniParams[199].y

void main(
  float4 v0 : POSITION0,
  float4 v1 : COLOR0,
  float2 v2 : TEXCOORD0,
  uint vertex : SV_VertexID,
  out float4 o0 : SV_POSITION0,
  out float4 o1 : COLOR0,
  out float4 o2 : TEXCOORD0,
  out float4 o3 : TEXCOORD1)
{
  float4 r0,r1;
  uint4 bitmask, uiDest;
  float4 fDest;
  
  	switch(vertex % 4) {
		case 0:
			v0.xy = v0.xy + float2(-SIZE,SIZE);
			o2.xy = float2(0,1);
			break;
		case 1:
			v0.xy = v0.xy + float2(-SIZE,-SIZE);
			o2.xy = float2(0,0);
			break;
		case 2:
			v0.xy = v0.xy + float2(SIZE,SIZE);
			o2.xy = float2(1,1);
			break;
		case 3:
			v0.xy = v0.xy + float2(SIZE,-SIZE);
			o2.xy = float2(1,0);
			break;
		default:
			o2.xy = float2(0,0);
			break;
	};
  
  
  r0.xyzw = cb1[1].xyzw * v0.yyyy;
  r0.xyzw = cb1[0].xyzw * v0.xxxx + r0.xyzw;
  r0.xyzw = cb1[2].xyzw * v0.zzzz + r0.xyzw;
  r0.xyzw = cb1[3].xyzw + r0.xyzw;
  r1.xyzw = cb2[18].xyzw * r0.yyyy;
  r1.xyzw = cb2[17].xyzw * r0.xxxx + r1.xyzw;
  r1.xyzw = cb2[19].xyzw * r0.zzzz + r1.xyzw;
  o0.xyzw = cb2[20].xyzw * r0.wwww + r1.xyzw;
  
  o2.zw = float2(0,0);
  o1 = v2.xyxx;
  o3 = v2.xyxx;
  return;
}
