RWBuffer<float> u1 : register(u1);
RWBuffer<float> u3 : register(u3);

Texture2D<float4> StereoParams : register(t125);
Texture1D<float4> IniParams : register(t120);

#define ID IniParams[254].x

[numthreads(1,1,1)]
void main(uint3 DTid : SV_DispatchThreadID)
{	
	if (u1[ID] == 1) u1[ID] = 0;
	else u1[ID] = 1;
	
	float binary_array[23];
	int i;
	
	int index = ID / 23;
	index = index * 23;
	
	for (i = 0; i < 23; i++)
    {
        binary_array[i] = u1[index + i];
    }
	
	float result = 0;
	for (i = 0; i < 23; i++) result += (pow(2, i) * binary_array[22 - i]);
	
	u3[33] = result;
}
