// ---- Created with 3Dmigoto v1.3.16 on Fri Dec 22 22:14:01 2023
cbuffer cb2 : register(b2)
{
  float4 cb2[21];
}

cbuffer cb1 : register(b1)
{
  float4 cb1[4];
}

cbuffer cb0 : register(b0)
{
  float4 cb0[11];
}

struct vb_struct {
    float3 POSITION; 	// Offset:    0
	float3 NORMAL; 		// Offset:    12
	uint COLOR; 		// Offset:    24 (Всегда float4(1,1,1,1). Такое чтение не правильное но обеспечивает правильный отступ)
	float2 TEXCOORD; 	// Offset:    28
	float2 TEXCOORD1; 	// Offset:    36
	float4 TANGENT; 	// Offset:    44
};

StructuredBuffer<vb_struct> vb0 : register(t0);


// 3Dmigoto declarations
#define cmp -
Texture1D<float4> IniParams : register(t120);
Texture2D<float4> StereoParams : register(t125);

RWBuffer<float4> u1 : register(u1);

[numthreads(1,1,1)]
void main(uint3 DTid : SV_DispatchThreadID)
{	
  float4 r0,r1,r2,r3,r4,o0,o1,o2;
  uint4 bitmask, uiDest;
  float4 fDest;
  
  float4 v0 = float4(-99999,-99999,0,0);
  float4 v1 = float4(1,1,1,1);
  float4 v2 = float4(vb0[0].TEXCOORD,0,0);
  float2 v3 = vb0[0].TEXCOORD1;
  float3 v4 = vb0[0].NORMAL;
  float4 v5 = vb0[0].TANGENT;
  
  r0.x = cb0[7].x;
  r0.y = cb0[8].y;
  r0.xy = float2(0.5,0.5) / r0.xy;
  r0.zw = -cb0[10].xy * r0.xy;
  r1.xy = r0.zw * float2(2,2) + -r0.xy;
  r1.z = dot(v4.xy, v4.xy);
  r1.w = rsqrt(r1.z);
  r2.x = sqrt(r1.z);
  r1.zw = v4.xy * r1.ww;
  r3.x = dot(r1.zw, r1.xy);
  r2.z = dot(v5.xy, v5.xy);
  r2.w = rsqrt(r2.z);
  r2.y = sqrt(r2.z);
  r2.zw = v5.xy * r2.ww;
  r3.y = dot(r2.zw, r1.xy);
  r1.xy = r0.zw + r0.zw;
  r0.zw = r0.zw * float2(2,2) + r0.xy;
  r4.xyzw = r0.xyxy * float4(-1,1,1,-1) + r1.xyxy;
  r0.x = dot(r1.zw, r1.xy);
  r0.y = dot(r2.zw, r1.xy);
  r1.xy = min(r0.xy, r3.xy);
  r0.xy = max(r0.xy, r3.xy);
  r3.x = dot(r1.zw, r4.xy);
  r3.y = dot(r2.zw, r4.xy);
  r1.xy = min(r3.xy, r1.xy);
  r0.xy = max(r3.xy, r0.xy);
  r3.x = dot(r1.zw, r0.zw);
  r3.y = dot(r2.zw, r0.zw);
  r0.zw = min(r3.xy, r1.xy);
  r0.xy = max(r3.xy, r0.xy);
  r1.x = dot(r1.zw, r4.zw);
  r1.y = dot(r2.zw, r4.zw);
  r0.zw = min(r1.xy, r0.zw);
  r0.xy = max(r1.xy, r0.xy);
  r1.x = dot(r1.zw, v0.xy);
  r1.y = dot(r2.zw, v0.xy);
  r0.zw = max(r1.xy, r0.zw);
  r0.xy = min(r0.zw, r0.xy);
  r0.zw = r0.yy * r2.zw;
  r0.zw = r0.xx * r1.zw + r0.zw;
  r0.xy = r0.xy + -r1.xy;
  r0.xy = v3.xy * r0.xy;
  r0.xy = r0.xy / r2.xy;
  o1.xy = v2.xy + r0.xy;
  o1.zw = float2(0,0);
  r1.xyzw = cb1[1].xyzw * r0.wwww;
  r1.xyzw = cb1[0].xyzw * r0.zzzz + r1.xyzw;
  r1.xyzw = cb1[2].xyzw * v0.zzzz + r1.xyzw;
  r1.xyzw = cb1[3].xyzw + r1.xyzw;
  r2.xyzw = cb2[18].xyzw * r1.yyyy;
  r2.xyzw = cb2[17].xyzw * r1.xxxx + r2.xyzw;
  r2.xyzw = cb2[19].xyzw * r1.zzzz + r2.xyzw;
  o0.xyzw = cb2[20].xyzw * r1.wwww + r2.xyzw;
  
  u1[0] = o0;
  
  v0 = float4(99999,99999,0,0);

  r0.x = cb0[7].x;
  r0.y = cb0[8].y;
  r0.xy = float2(0.5,0.5) / r0.xy;
  r0.zw = -cb0[10].xy * r0.xy;
  r1.xy = r0.zw * float2(2,2) + -r0.xy;
  r1.z = dot(v4.xy, v4.xy);
  r1.w = rsqrt(r1.z);
  r2.x = sqrt(r1.z);
  r1.zw = v4.xy * r1.ww;
  r3.x = dot(r1.zw, r1.xy);
  r2.z = dot(v5.xy, v5.xy);
  r2.w = rsqrt(r2.z);
  r2.y = sqrt(r2.z);
  r2.zw = v5.xy * r2.ww;
  r3.y = dot(r2.zw, r1.xy);
  r1.xy = r0.zw + r0.zw;
  r0.zw = r0.zw * float2(2,2) + r0.xy;
  r4.xyzw = r0.xyxy * float4(-1,1,1,-1) + r1.xyxy;
  r0.x = dot(r1.zw, r1.xy);
  r0.y = dot(r2.zw, r1.xy);
  r1.xy = min(r0.xy, r3.xy);
  r0.xy = max(r0.xy, r3.xy);
  r3.x = dot(r1.zw, r4.xy);
  r3.y = dot(r2.zw, r4.xy);
  r1.xy = min(r3.xy, r1.xy);
  r0.xy = max(r3.xy, r0.xy);
  r3.x = dot(r1.zw, r0.zw);
  r3.y = dot(r2.zw, r0.zw);
  r0.zw = min(r3.xy, r1.xy);
  r0.xy = max(r3.xy, r0.xy);
  r1.x = dot(r1.zw, r4.zw);
  r1.y = dot(r2.zw, r4.zw);
  r0.zw = min(r1.xy, r0.zw);
  r0.xy = max(r1.xy, r0.xy);
  r1.x = dot(r1.zw, v0.xy);
  r1.y = dot(r2.zw, v0.xy);
  r0.zw = max(r1.xy, r0.zw);
  r0.xy = min(r0.zw, r0.xy);
  r0.zw = r0.yy * r2.zw;
  r0.zw = r0.xx * r1.zw + r0.zw;
  r0.xy = r0.xy + -r1.xy;
  r0.xy = v3.xy * r0.xy;
  r0.xy = r0.xy / r2.xy;
  o1.xy = v2.xy + r0.xy;
  o1.zw = float2(0,0);
  r1.xyzw = cb1[1].xyzw * r0.wwww;
  r1.xyzw = cb1[0].xyzw * r0.zzzz + r1.xyzw;
  r1.xyzw = cb1[2].xyzw * v0.zzzz + r1.xyzw;
  r1.xyzw = cb1[3].xyzw + r1.xyzw;
  r2.xyzw = cb2[18].xyzw * r1.yyyy;
  r2.xyzw = cb2[17].xyzw * r1.xxxx + r2.xyzw;
  r2.xyzw = cb2[19].xyzw * r1.zzzz + r2.xyzw;
  o0.xyzw = cb2[20].xyzw * r1.wwww + r2.xyzw;
  
  u1[1] = o0;
  u1[2] = (u1[0] + u1[1])/2.0;
  u1[3] = float4(abs(u1[1].x - u1[2].x),abs(u1[1].y - u1[2].y),0,0);
  
  return;
}
