RWBuffer<float> PointID : register(u1);

Texture2D<float4> StereoParams : register(t125);
Texture1D<float4> IniParams : register(t120);

[numthreads(1,1,1)]
void main(uint3 DTid : SV_DispatchThreadID)
{
	int index = (DTid.x * 23) + (0 * 23);
	int bufindex = DTid.x / 4;
    uint datapack = 0;
	int i = 0;
	
	switch(DTid.x % 4) {
		case 0:
			datapack = int(IniParams[bufindex].x);
			break;
		case 1:
			datapack = int(IniParams[bufindex].y);
			break;
		case 2:
			datapack = int(IniParams[bufindex].z);
			break;
		case 3:
			datapack = int(IniParams[bufindex].w);
			break;
		default:
			datapack = 0;
			break;
	};
	
	for (i = 0; i < 23; ++i)
	{
		PointID[index + 22 - i] = datapack % 2;
		datapack /= 2;
	}
    
}